<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>ConditionalFormattingEvaluator (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ConditionalFormattingEvaluator (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":9,"i9":10,"i10":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/ConditionalFormattingEvaluator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li>
            <a href="../../../../../org/apache/poi/ss/formula/CollaboratingWorkbooksEnvironment.WorkbookNotFoundException.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html"
               target="_top">Frames</a></li>
        <li><a href="ConditionalFormattingEvaluator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula</div>
    <h2 title="Class ConditionalFormattingEvaluator" class="title">Class ConditionalFormattingEvaluator</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.formula.ConditionalFormattingEvaluator</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">ConditionalFormattingEvaluator</span>
extends java.lang.Object</pre>
                <div class="block">Evaluates Conditional Formatting constraints.<p>

                    For performance reasons, this class keeps a cache of all previously evaluated rules and cells.
                    Be sure to call <a
                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#clearAllCachedFormats--"><code>clearAllCachedFormats()</code></a>
                    if any conditional formats are modified, added, or deleted,
                    and <a
                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#clearAllCachedValues--"><code>clearAllCachedValues()</code></a>
                    whenever cell values change.
                    <p></div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#ConditionalFormattingEvaluator-org.apache.poi.ss.usermodel.Workbook-org.apache.poi.ss.formula.WorkbookEvaluatorProvider-">ConditionalFormattingEvaluator</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Workbook.html"
                                        title="interface in org.apache.poi.ss.usermodel">Workbook</a>&nbsp;wb,
                                    <a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluatorProvider.html"
                                       title="interface in org.apache.poi.ss.formula">WorkbookEvaluatorProvider</a>&nbsp;provider)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#clearAllCachedFormats--">clearAllCachedFormats</a></span>()</code>
                                    <div class="block">Call this whenever rules are added, reordered, or removed, or a
                                        rule formula is changed
                                        (not the formula inputs but the formula expression itself)
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#clearAllCachedValues--">clearAllCachedValues</a></span>()</code>
                                    <div class="block">Call this whenever cell values change in the workbook, so
                                        condional formats are re-evaluated
                                        for all cells.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getConditionalFormattingForCell-org.apache.poi.ss.usermodel.Cell-">getConditionalFormattingForCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</code>
                                    <div class="block">This checks all applicable <a
                                            href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormattingRule.html"
                                            title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormattingRule</code></a>s
                                        for the cell's sheet,
                                        in defined "priority" order, returning the matches if any.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getConditionalFormattingForCell-org.apache.poi.ss.util.CellReference-">getConditionalFormattingForCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cellRef)</code>
                                    <div class="block">This checks all applicable <a
                                            href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormattingRule.html"
                                            title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormattingRule</code></a>s
                                        for the cell's sheet,
                                        in defined "priority" order, returning the matches if any.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getFormatRulesForSheet-org.apache.poi.ss.usermodel.Sheet-">getFormatRulesForSheet</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Sheet.html"
                                        title="interface in org.apache.poi.ss.usermodel">Sheet</a>&nbsp;sheet)</code>
                                    <div class="block">Retrieve all formatting rules for the given sheet.</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getFormatRulesForSheet-java.lang.String-">getFormatRulesForSheet</a></span>(java.lang.String&nbsp;sheetName)</code>
                                    <div class="block">Retrieve all formatting rules for the sheet with the given
                                        name.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getMatchingCells-org.apache.poi.ss.formula.EvaluationConditionalFormatRule-">getMatchingCells</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&nbsp;rule)</code>
                                    <div class="block">Retrieve all cells where the given formatting rule evaluates to
                                        true.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getMatchingCells-org.apache.poi.ss.usermodel.Sheet-int-int-">getMatchingCells</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Sheet.html"
                                        title="interface in org.apache.poi.ss.usermodel">Sheet</a>&nbsp;sheet,
                                    int&nbsp;conditionalFormattingIndex,
                                    int&nbsp;ruleIndex)</code>
                                    <div class="block">Conditional formatting rules can apply only to cells in the sheet
                                        to which they are attached.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getRef-org.apache.poi.ss.usermodel.Cell-">getRef</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>protected java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getRules-org.apache.poi.ss.usermodel.Sheet-">getRules</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Sheet.html"
                                        title="interface in org.apache.poi.ss.usermodel">Sheet</a>&nbsp;sheet)</code>
                                    <div class="block">lazy load by sheet since reading can be expensive</div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html"
                                        title="class in org.apache.poi.ss.formula">WorkbookEvaluator</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html#getWorkbookEvaluator--">getWorkbookEvaluator</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="ConditionalFormattingEvaluator-org.apache.poi.ss.usermodel.Workbook-org.apache.poi.ss.formula.WorkbookEvaluatorProvider-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>ConditionalFormattingEvaluator</h4>
                                <pre>public&nbsp;ConditionalFormattingEvaluator(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Workbook.html"
                                        title="interface in org.apache.poi.ss.usermodel">Workbook</a>&nbsp;wb,
                                      <a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluatorProvider.html"
                                         title="interface in org.apache.poi.ss.formula">WorkbookEvaluatorProvider</a>&nbsp;provider)</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getWorkbookEvaluator--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getWorkbookEvaluator</h4>
                                <pre>protected&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html"
                                        title="class in org.apache.poi.ss.formula">WorkbookEvaluator</a>&nbsp;getWorkbookEvaluator()</pre>
                            </li>
                        </ul>
                        <a name="clearAllCachedFormats--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>clearAllCachedFormats</h4>
                                <pre>public&nbsp;void&nbsp;clearAllCachedFormats()</pre>
                                <div class="block">Call this whenever rules are added, reordered, or removed, or a rule
                                    formula is changed
                                    (not the formula inputs but the formula expression itself)
                                </div>
                            </li>
                        </ul>
                        <a name="clearAllCachedValues--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>clearAllCachedValues</h4>
                                <pre>public&nbsp;void&nbsp;clearAllCachedValues()</pre>
                                <div class="block">Call this whenever cell values change in the workbook, so condional
                                    formats are re-evaluated
                                    for all cells.
                                    <p>
                                        TODO: eventually this should work like <code>EvaluationCache.notifyUpdateCell(int,
                                        int, EvaluationCell)</code>
                                        and only clear values that need recalculation based on the formula dependency
                                        tree.</div>
                            </li>
                        </ul>
                        <a name="getRules-org.apache.poi.ss.usermodel.Sheet-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRules</h4>
                                <pre>protected&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;&nbsp;getRules(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Sheet.html"
                                        title="interface in org.apache.poi.ss.usermodel">Sheet</a>&nbsp;sheet)</pre>
                                <div class="block">lazy load by sheet since reading can be expensive</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>sheet</code> - The sheet to look at</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>unmodifiable list of rules</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getConditionalFormattingForCell-org.apache.poi.ss.util.CellReference-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getConditionalFormattingForCell</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;&nbsp;getConditionalFormattingForCell(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cellRef)</pre>
                                <div class="block">This checks all applicable <a
                                        href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormattingRule.html"
                                        title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormattingRule</code></a>s
                                    for the cell's sheet,
                                    in defined "priority" order, returning the matches if any. This is a property
                                    currently
                                    not exposed from <code>CTCfRule</code> in <code>XSSFConditionalFormattingRule</code>.
                                    <p>
                                        Most cells will have zero or one applied rule, but it is possible to define
                                        multiple rules
                                        that apply at the same time to the same cell, thus the List result.
                                    <p>
                                        Note that to properly apply conditional rules, care must be taken to offset the
                                        base
                                        formula by the relative position of the current cell, or the wrong value is
                                        checked.
                                        This is handled by <a
                                            href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-java.lang.String-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-"><code>WorkbookEvaluator.evaluate(String,
                                        CellReference, CellRangeAddressBase)</code></a>.
                                    <p>
                                        If the cell exists and is a formula cell, its cached value may be used for rule
                                        evaluation, so
                                        make sure it is up to date. If values have changed, it is best to call
                                        <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html#evaluateFormulaCell-org.apache.poi.ss.usermodel.Cell-"><code>FormulaEvaluator.evaluateFormulaCell(Cell)</code></a>
                                        or <a
                                            href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html#evaluateAll--"><code>FormulaEvaluator.evaluateAll()</code></a>
                                        first,
                                        or the wrong conditional results may be returned.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cellRef</code> - NOTE: if no sheet name is specified, this uses the
                                        workbook active sheet
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>Unmodifiable List of <a
                                            href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                            title="class in org.apache.poi.ss.formula"><code>EvaluationConditionalFormatRule</code></a>s
                                        that apply to the current cell value,
                                        in priority order, as evaluated by Excel (smallest priority # for XSSF,
                                        definition order for HSSF),
                                        or null if none apply
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getConditionalFormattingForCell-org.apache.poi.ss.usermodel.Cell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getConditionalFormattingForCell</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;&nbsp;getConditionalFormattingForCell(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</pre>
                                <div class="block">This checks all applicable <a
                                        href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormattingRule.html"
                                        title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormattingRule</code></a>s
                                    for the cell's sheet,
                                    in defined "priority" order, returning the matches if any. This is a property
                                    currently
                                    not exposed from <code>CTCfRule</code> in <code>XSSFConditionalFormattingRule</code>.
                                    <p>
                                        Most cells will have zero or one applied rule, but it is possible to define
                                        multiple rules
                                        that apply at the same time to the same cell, thus the List result.
                                    <p>
                                        Note that to properly apply conditional rules, care must be taken to offset the
                                        base
                                        formula by the relative position of the current cell, or the wrong value is
                                        checked.
                                        This is handled by <a
                                            href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-java.lang.String-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-"><code>WorkbookEvaluator.evaluate(String,
                                        CellReference, CellRangeAddressBase)</code></a>.
                                    <p>
                                        If the cell exists and is a formula cell, its cached value may be used for rule
                                        evaluation, so
                                        make sure it is up to date. If values have changed, it is best to call
                                        <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html#evaluateFormulaCell-org.apache.poi.ss.usermodel.Cell-"><code>FormulaEvaluator.evaluateFormulaCell(Cell)</code></a>
                                        or <a
                                            href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html#evaluateAll--"><code>FormulaEvaluator.evaluateAll()</code></a>
                                        first,
                                        or the wrong conditional results may be returned.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The cell to look for</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>Unmodifiable List of <a
                                            href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                            title="class in org.apache.poi.ss.formula"><code>EvaluationConditionalFormatRule</code></a>s
                                        that apply to the current cell value,
                                        in priority order, as evaluated by Excel (smallest priority # for XSSF,
                                        definition order for HSSF),
                                        or null if none apply
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getRef-org.apache.poi.ss.usermodel.Cell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRef</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;getRef(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</pre>
                            </li>
                        </ul>
                        <a name="getFormatRulesForSheet-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getFormatRulesForSheet</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;&nbsp;getFormatRulesForSheet(java.lang.String&nbsp;sheetName)</pre>
                                <div class="block">Retrieve all formatting rules for the sheet with the given name.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>sheetName</code> - The name of the sheet to look at</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>unmodifiable list of all Conditional format rules for the given sheet, if any
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getFormatRulesForSheet-org.apache.poi.ss.usermodel.Sheet-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getFormatRulesForSheet</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&gt;&nbsp;getFormatRulesForSheet(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Sheet.html"
                                        title="interface in org.apache.poi.ss.usermodel">Sheet</a>&nbsp;sheet)</pre>
                                <div class="block">Retrieve all formatting rules for the given sheet.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>sheet</code> - The sheet to look at</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>unmodifiable list of all Conditional format rules for the given sheet, if any
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getMatchingCells-org.apache.poi.ss.usermodel.Sheet-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMatchingCells</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&gt;&nbsp;getMatchingCells(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Sheet.html"
                                        title="interface in org.apache.poi.ss.usermodel">Sheet</a>&nbsp;sheet,
                                             int&nbsp;conditionalFormattingIndex,
                                             int&nbsp;ruleIndex)</pre>
                                <div class="block">Conditional formatting rules can apply only to cells in the sheet to
                                    which they are attached.
                                    The POI data model does not have a back-reference to the owning sheet, so it must be
                                    passed in separately.
                                    <p>
                                        We could overload this with convenience methods taking a sheet name and sheet
                                        index as well.
                                    <p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>sheet</code> - containing the rule</dd>
                                    <dd><code>conditionalFormattingIndex</code> - of the <a
                                            href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormatting.html"
                                            title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormatting</code></a>
                                        instance in the sheet's array
                                    </dd>
                                    <dd><code>ruleIndex</code> - of the <a
                                            href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormattingRule.html"
                                            title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormattingRule</code></a>
                                        instance within the <a
                                                href="../../../../../org/apache/poi/ss/usermodel/ConditionalFormatting.html"
                                                title="interface in org.apache.poi.ss.usermodel"><code>ConditionalFormatting</code></a>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>unmodifiable List of all cells in the rule's region matching the rule's
                                        condition
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getMatchingCells-org.apache.poi.ss.formula.EvaluationConditionalFormatRule-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getMatchingCells</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&gt;&nbsp;getMatchingCells(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationConditionalFormatRule.html"
                                        title="class in org.apache.poi.ss.formula">EvaluationConditionalFormatRule</a>&nbsp;rule)</pre>
                                <div class="block">Retrieve all cells where the given formatting rule evaluates to
                                    true.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>rule</code> - The rule to look at</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>unmodifiable List of all cells in the rule's region matching the rule's
                                        condition
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/ConditionalFormattingEvaluator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li>
            <a href="../../../../../org/apache/poi/ss/formula/CollaboratingWorkbooksEnvironment.WorkbookNotFoundException.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html"
               target="_top">Frames</a></li>
        <li><a href="ConditionalFormattingEvaluator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
